//
//  PErasureMatrix.h
//  PErasureShareMemory
//
//  Created by Liu Chengjian on 16/8/15.
//  Copyright (c) 2016年 csliu. All rights reserved.
//

#ifndef __PErasureShareMemory__PErasureMatrix__
#define __PErasureShareMemory__PErasureMatrix__


  int perasure_check_k_m_w(int k, int m, int w);

  int *perasure_create_bitmatrix(int k, int m, int w);

  unsigned int *perasure_create_column_encoded_bitmatrix(int k, int m, int w,
                                                                  int *bitmatrix);

  int perasure_create_decoding_data_bitmatrix(int k, int m, int w,
                                                        int *matrix, int *decoding_data_matrix,
                                                        int *erased, int *dm_ids);
  int* perasure_create_decoding_bitmatrix(int k, int m, int w,
                                                   int *matrix, int *mat_idx,
                                                   int *erasures, int *dm_ids);

  int perasure_generate_coding_vector(int k, int m, int w, int mIdx,
                                    int *matrix, int *invert_matrix, int *vector,
                                    int *erases);

  int *perasure_erasures_to_erased(int k, int m,
                                            int *erasures);

  void printMatrix(int *mat, int coloum, int row);
  void perasure_print_column_encoded_bitmatrix(unsigned int *column_encoded_bitmatrix, int k, int m, int w);
#endif /* defined(__PErasureShareMemory__PErasureMatrix__) */
