//
//  PErasureMeasure.h
//  PBase
//
//  Created by Liu Chengjian on 16/10/27.
//  Copyright (c) 2016年 csliu. All rights reserved.
//

#ifndef __PBase__PErasureMeasure__
#define __PBase__PErasureMeasure__

#include <stdio.h>

void perform_base_coding(char *in, char *out,
                         int *bitmatrix,
                         int k, int m, int w,
                         int threadDimX,int blockDimX,
                         int workSizePerGridInLong);

void measure_correctness(int k, int m, int w);

void measure_base_work_size_time_avg(int k, int m, int w,
                                     int workSizePerDataParityBlock, int loopNum,
                                     double *encodeTimeElapse, double *encodeTimeVariance,
                                     double *decodeTimeElapse, double *decodeTimeVariance);

#endif /* defined(__PBase__PErasureMeasure__) */
